#include "mbed.h"
#include "SLCD.h"


#define PROGNAME "lightsense_kl46z_PWM v1\n\r"
#define DATATIME 400 // milliseconds //looks like this might have something to do with it.
#define LCDLEN 10 //I don't think this will effect the position.
#define LIGHTSENSORPORT PTE22



SLCD slcd; //define LCD display globally define
Serial pc(USBTX, USBRX);
Timer LEDTimer;

void LCDMess(char *lMess){
        slcd.Home();
        slcd.clear();
        slcd.printf(lMess);
} 

int main() {
    PwmOut greenColor(LED_GREEN);
    PwmOut redColor(LED_RED);
    AnalogIn LightSensor(LIGHTSENSORPORT);
    float lightData; 
    char lcdData[LCDLEN];
   
    int timeToChangeDF = DATATIME;
    // set up timer for next step of Duty Factor timing
    LEDTimer.start();
    LEDTimer.reset();
    pc.printf(PROGNAME);
    
    
    while(true) {    
        if (LEDTimer.read_ms() > timeToChangeDF){ // check for timer time out transtion
            lightData = (1.0 - LightSensor.read()); // show as increasiing with increasing intensity
            greenColor.write(1.0- lightData);
            redColor.write(1.0-lightData); //I'm assuming this where the actions take place?
            sprintf(lcdData,"%4.3f",lightData);
            LCDMess(lcdData);  
            pc.printf("%4.3f\r\n",lightData);
            timeToChangeDF = DATATIME;
            LEDTimer.reset();
        }        
    }// emd while
}
